/* 
xagent offline NNTP news reader
xagent is registered Copyright (C) 1997 <Jan Mourer>
email: pante@pi.net
snail mail: PO BOX 61  SINT ANNA  9076ZP HOLLAND

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xagent.h"

extern FD_xagent *fd_xagent;
extern FD_xagent *fdui;


void posting_editor_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(posting_body_editor_fontsize < 5) posting_body_editor_fontsize++;
size = integer_to_fontsize(posting_body_editor_fontsize);

fl_set_object_lsize(fdui -> posting_body_editor, size);
save_fontsizes();
}/* end function posting_editor_fontsize_up_button_cb */


void posting_editor_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(posting_body_editor_fontsize > 0) posting_body_editor_fontsize--;
size = integer_to_fontsize(posting_body_editor_fontsize);

fl_set_object_lsize(fdui -> posting_body_editor, size);
save_fontsizes();
}/* end function posting_editor_fontsize_down_button_cb */


void posting_send_now_button_cb(FL_OBJECT *ob, long data)
{
int type;
int a;
int topline;

if(debug_flag)
	{
	fprintf(stdout, "send_now_button_cb(): arg none\n");
	}

/* parameter check :) */
if(strlen(fl_get_input(fdui -> posting_to_input_field) ) == 0)
	{
	fl_show_alert(\
	"No newsgroup or email address specified",\
	"fill in destination", "", 0);
	return;
	}

if(strlen(fl_get_input(fdui -> posting_subject_input_field) ) == 0)
	{
	fl_show_alert("No subject specified", "fill in subject field", "", 0);
	return;
	}

if(strlen(fl_get_input(fdui -> posting_body_editor) ) == 0)
	{
	fl_show_alert("No text specified", "enter some text", "", 0);
	return;
	}

a = save_posting(selected_group, selected_article, SEND_NOW);

if(a)
	{
	type = get_posting_type(body_posting);
	if( (type == NEW_ARTICLE) || (type == FOLLOW_UP_ARTICLE) )
		{
		add_to_command_queue("dummy", body_posting , POST_ARTICLE);
		}
	if(type == REPLY_VIA_EMAIL)
		{
		add_to_command_queue("dummy", body_posting , EMAIL_ARTICLE);
		}
	}

fl_hide_form(fd_xagent -> posting_editor);

/* show transmit status */
fl_set_object_label(fdui -> description_display, "POSTING LIST");
show_browser(POSTING_LIST_BROWSER);

refresh_screen(selected_group);

/* make the status of the last article visible */
topline = fl_get_browser_maxline(fdui -> posting_list_browser);
fl_set_browser_topline(fdui -> posting_list_browser, topline);

if(a) process_command_queue_error_flag = 0;
}/* end function posting_send_now_button_cb */


void posting_send_later_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)fprintf(stdout, "send_later_button_cb(): arg none\n");

save_posting(selected_group, selected_article, SEND_LATER);

fl_hide_form(fd_xagent -> posting_editor);

/*
fl_set_object_label(fdui -> description_display, "POSTING LIST");
show_browser(POSTING_LIST_BROWSER);
*/
refresh_screen(selected_group);
}/* end function posting_send_later_button_cb */


void posting_cancel_button_cb(FL_OBJECT *ob, long data)
{
fl_set_object_label(fdui -> description_display, "POSTING LIST");

fl_hide_form(fd_xagent -> posting_editor);
}/* end function posting_cancel_button_cb */


void posting_to_input_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)fprintf(stdout, "TO INPUT CB\n");
posting_modified_flag = 1;
}/* end function posting_to_input_cb */


void posting_subject_input_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)fprintf(stdout, "SUBJECT INPUT CB\n");
posting_modified_flag = 1;
}/* end function posting_subject_input_cb */


void posting_attachment_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;
FILE *attachment_fileptr;
if(debug_flag)fprintf(stdout, "SUBJECT INPUT CB\n");

/* test if attachment file exists */
ptr = (char *) fl_get_input(fdui -> posting_attachment_input_field);
attachment_fileptr = fopen(ptr, "r");
if(! attachment_fileptr)
	{
	fl_show_alert("Cannot open attachment", ptr, "file not found", 0); 
	}
else fclose(attachment_fileptr);

posting_modified_flag = 1;
}/* end function posting_attachment_input_cb */


void posting_body_editor_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)fprintf(stdout, "posting_body_editor_cb(): arg none\n");
posting_modified_flag = 1;
}/* end function posting_body_editor_cb */


void posting_summary_button_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(fdui -> summary_editor_input_field);
if(! ptr) return;

free(summary_input);
summary_input = strsave(ptr);

fl_show_form(fdui -> summary_editor, FL_PLACE_CENTER, FL_NOBORDER, "");
}/* end function posting_summary_button_cb */


void posting_custom_headers_button_cb(FL_OBJECT *ob, long data)
{
int c;
char temp[512];
FILE *load_filefd;
struct stat *statptr;
char *space, *spaceptr;

/* display the global headers in the global headers editor (if any ) */
sprintf(temp, "%s/.xagent/global_custom_head", home_dir);
load_filefd = fopen(temp, "r");

/* clear display */
fl_set_input(fdui -> global_custom_headers_editor_input_field, "");
if(load_filefd)
	{
	statptr = (struct stat*) malloc(sizeof(struct stat) );
	if(! statptr) return;
	fstat(fileno(load_filefd), statptr);
	
	space = malloc(statptr -> st_size + 1);
	free(statptr);
	if(! space)
		{
		if(debug_flag)
			{
			fprintf(stdout,\
	"posting_custom_headers_button_cb(): malloc could not allocate space\n");
			}
		return;
		}

	spaceptr = space;
	while(1)
		{
		while(1)/* error re read */
			{
			c = getc(load_filefd);
			if(! ferror(load_filefd) ) break;
			perror(\
			"custom_headers_button_cb(): global_custom_header read failed ");
			}/* end while error re read */	

		if(feof(load_filefd) )
			{
			fclose(load_filefd);
			break;
			}
		*spaceptr = c;
		spaceptr++;
		}/* end while all lines from article body */
	*spaceptr = 0;/* string termination */

	fl_set_input(fdui -> global_custom_headers_editor_input_field, space);
	free(space);

	}/* end if global headers file open ok (present) */

get_custom_headers_flag(selected_posting, &custom_headers_state);
headers_modified_flag = 0;

fl_show_form(fd_xagent -> custom_headers_editor,\
FL_PLACE_CENTER, FL_NOBORDER, "");
}/* end function posting_custom_headers_button_cb */


void posting_attach_file_button_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_show_fselector("SELECT AN ATTACHMENT", home_dir, "*", "*");
if(! ptr) return;

if(debug_flag)
	{
	fprintf(stdout, "attach_file_button_cb(): selected=%s\n", ptr);
	}

fl_set_input(fdui -> posting_attachment_input_field, ptr);
posting_modified_flag = 1;
}/* end function posting_attach_file_buttun_cb */


void posting_insert_file_button_cb(FL_OBJECT *ob, long data)
{
int c, i;
int cupos, cux, cuy;
int topline;
char *ptr;
char *input_field_ptr;
struct stat *statptr;
char *space, *spaceptr;
FILE *insert_filefd;
char insert_filename[512];

/* get cursor position */
cupos = fl_get_input_cursorpos(fdui -> posting_body_editor, &cux, &cuy);
if(cupos == -1)/* field not selected */
	{
	fl_show_alert(\
	"Select a position in the posting body editor first", "", "", 0);
	return;
	}

topline = fl_get_input_topline(fdui -> posting_body_editor);

/* start file browser */
ptr = (char *) fl_show_fselector("SELECT A FILE", home_dir, "*", "*");
if(! ptr) return;
if(debug_flag)
	{
	fprintf(stdout,\
	"posting_insert_file_button_cb(): selected=%s\n", ptr);
	}

/* try to open file for read */
sprintf(insert_filename, ptr);
insert_filefd = fopen(insert_filename, "r");
if(! insert_filefd)
	{
	fl_show_alert("Cannot open file", insert_filename, "for read", 0);
	return;
	}

/* get length from input */
input_field_ptr = (char *) fl_get_input(fdui -> posting_body_editor);
if(! input_field_ptr) return;

/* create space for total */
statptr = (struct stat*) malloc(sizeof(struct stat) );
if(! statptr) return;

fstat(fileno(insert_filefd), statptr);

space = malloc(statptr -> st_size + strlen(input_field_ptr) + 2);
free(statptr);
if(! space) return;

/* read from input field until cursor position into space */
spaceptr = space;
for(i = 0; i < cupos; i++)
	{
	c = input_field_ptr[i];
	*spaceptr = c;
	if(c == 0) break;/* end of string */
	spaceptr++;
	}

/* read from file */
while(1)
	{
	while(1)/* error re read */
		{
		c = getc(insert_filefd);
		if(! ferror(insert_filefd) ) break;
		perror("posting_insert_file(): read failed ");
		}/* end while error re read */	

	if(feof(insert_filefd) )
		{
		fclose(insert_filefd);
		break;
		}
	*spaceptr = c;
	spaceptr++;
	}/* end while all lines from posting body */

/* read from input field again */
while(1)
	{
	c = input_field_ptr[i];
	*spaceptr = c;
	if(c == 0) break;/* end of string */
	spaceptr++;
	i++;
	}
*spaceptr = 0;/* string termination */

fl_set_input(fdui -> posting_body_editor, space);
fl_set_input_topline(fdui -> posting_body_editor, topline);
fl_set_input_cursorpos(fdui -> posting_body_editor, cux, cuy);

free(space);

posting_modified_flag = 1;
}/* end function posting_insert_file_button_cb */


/* UNTESTED */
void posting_write_file_button_cb(FL_OBJECT *ob, long data)
{
int c, i;
char temp[512];
int cupos, start, end;
char *ptr;
char *input_field_ptr;
FILE *write_filefd;
char write_filename[512];

/* get cursor position */
cupos = 0;
start = 0;
end = 0;

/*
Most unfortunatly this function does not exist yet in xforms.086
cupos = fl_get_input_selected(fdui -> posting_body_editor, &start, &end);
*/
if(cupos == -1)/* field not selected */
	{
	fl_show_alert(\
	"Select a position in the posting body editor first", "", "", 0);
	return;
	}

/* start file browser */
ptr = (char *) fl_show_fselector("SELECT A FILE", home_dir, "*", "*");
if(! ptr) return;
if(debug_flag)
	{
	fprintf(stdout,\
	"posting_write_file_button_cb(): selected=%s\n", ptr);
	}

/* test if file already exists */
/* try to open file for read */
sprintf(write_filename, ptr);
write_filefd = fopen(write_filename, "r");
if(write_filefd)
	{
	fclose(write_filefd);
	sprintf(temp, "File %s already exists, overwrite?", write_filename);
	if(! fl_show_question(temp, 3) ) return;
	}

/* try to open file for write */
sprintf(write_filename, ptr);
write_filefd = fopen(write_filename, "w");
if(! write_filefd)
	{
	fl_show_alert("Cannot open file", write_filename, "for write", 0);
	return;
	}

/* get input */
input_field_ptr = (char *) fl_get_input(fdui -> posting_body_editor);
if(! input_field_ptr) return;

for(i = start; i < end; i++)
	{
	c = input_field_ptr[i];
	while(1)
		{
		fputc(c, write_filefd);
		if(ferror(write_filefd) )
			{
			perror("posting_write_file_button_cb(): write failed ");
			continue;
			}
		else break;
		}
	}/* end for all selected chars */
fclose(write_filefd);
}/* end function posting_write_file_button_cb */


void posting_editor_clear_button_cb(FL_OBJECT *ob, long data)
{
/*
fprintf(stdout, "MIN MAX INT_MIN=%d INT_MAX=%d\n", INT_MIN, INT_MAX);
return;
*/

fl_set_input(fdui -> posting_body_editor, "");
}/* end function posting_editor_clear_button_cb */


