/* 
xagent offline NNTP news reader
xagent is registered Copyright (C) 1997 <Jan Mourer>
email: pante@pi.net
snail mail: PO BOX 61  SINT ANNA  9076ZP HOLLAND

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xagent.h"

extern FD_xagent *fd_xagent;
extern FD_xagent *fdui;


void helpers_editor_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(helpers_editor_fontsize < 5) helpers_editor_fontsize++;
size = integer_to_fontsize(helpers_editor_fontsize);

fl_set_object_lsize(fdui -> helpers_editor, size);
save_fontsizes();
}/* end function helpers_editor_fontsize_up_button_cb */


void helpers_editor_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(helpers_editor_fontsize > 0) helpers_editor_fontsize--;
size = integer_to_fontsize(helpers_editor_fontsize);

fl_set_object_lsize(fdui -> helpers_editor, size);
save_fontsizes();
}/* end function helpers_editor_fontsize_down_button_cb */


void get_new_headers_enable_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "get_new_headers_enable_button_cb(): arg none\n");
	} 
auto_get_new_headers_flag = fl_get_button(ob);
}/* end function get_new_headers_enable_button_cb */


void get_new_headers_time_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "get_new_headers_time_input_field_cb(): arg none\n");
	}

}/* end function get_new_headers_time_input_field_cb */


void pid_test_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "pid_test_input_field_cb(): arg none\n");
	}

/* test if pid file exists  not very usefull here */
}/* end function pid_test_input_field_cb */


void desc_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "desc_button_cb(): arg none\n");
	}

enable_description_popup_flag = fl_get_button(ob);
}/* end function desc_button_cb */


void auto_connect_to_net_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "auto_connect_net_button_cb(): arg none\n");
	} 
auto_connect_to_net_flag = fl_get_button(ob);
}/* end function auto_connect_to_net_button_cb */


void auto_connect_to_net_input_field_cb(FL_OBJECT *ob, long data)
{
FILE *autoconnect_filefd;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "auto_connect_to_net_input_field_cb(): arg none\n");
	}

/* test if auto connect file exists */
if(fl_get_button(fdui -> auto_connect_to_net_button) )
	{
	ptr = (char *) fl_get_input(fdui -> auto_connect_to_net_input_field);
	autoconnect_filefd = fopen(ptr, "r");
	if(! autoconnect_filefd)
		{
		fl_show_alert(\
		"Cannot open connect to net file", ptr, "file not found", 0); 
		}
	else fclose(autoconnect_filefd);
	}
}/* end function auto_connect_to_net_input_field_cb */


void auto_disconnect_from_net_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "auto_disconnect_button_cb(): arg none\n");
	}

auto_disconnect_from_net_flag = fl_get_button(ob);
}/* end function auto_disconnect_from_net_button_cb */


void auto_disconnect_from_net_input_field_cb(FL_OBJECT *ob, long data)
{
FILE *autodisconnect_filefd;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout,\
	"auto_disconnect_from_net_input_field_cb(): arg none\n");
	}

/* test if auto disconnect file exists */
if(fl_get_button(fdui -> auto_disconnect_from_net_button) )
	{
	ptr = (char *) fl_get_input(fdui -> auto_disconnect_from_net_input_field);
	autodisconnect_filefd = fopen(ptr, "r");
	if(! autodisconnect_filefd)
		{
		fl_show_alert("Cannot open disconnect from net file", ptr,\
		"file not found", 0); 
		}
	else fclose(autodisconnect_filefd);
	}
}/* end function auto_disconnect_from_net_input_field_cb */


void auto_execute_application_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "auto_execute_application_button_cb(): arg none\n");
	}

auto_execute_program_flag = fl_get_button(ob);
}/* end function auto_execute_application_button_cb */


void auto_execute_application_input_field_cb(FL_OBJECT *ob, long data)
{
FILE *auto_execute_filefd;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "auto_execute_application_input_field_cb(): arg none\n");
	}

if(fl_get_button(fdui -> auto_execute_application_button) )
	{
	/* test if auto disconnect file exists */
	ptr =\
	(char *) fl_get_input(fdui -> auto_execute_application_input_field);
	auto_execute_filefd = fopen(ptr, "r");
	if(! auto_execute_filefd)
		{
		fl_show_alert("Cannot find application", ptr,\
		"file not found", 0); 
		}
	else fclose(auto_execute_filefd);
	}
}/* end function auto_execute_application_input_field_cb */


void news_server_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "news_server_input_field_cb(): arg none\n");
	}
}/* end function news_server_input_field_cb */


void news_server_port_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "news_server_port_input_field_cb(): arg none\n");
	}
}/* end function news_server_port_input_field_cb */


void mail_server_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "mail_server_input_field_cb(): arg none\n");
	}
}/* end function mail_server_input_field_cb */


void user_name_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "user_name_input_field_cb(): arg none\n");
	}
}/* end function user_name_input_field_cb */


void user_email_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "user_email_input_field_cb(): arg none\n");
	}
}/* end function user_email_input_field_cb */


void maximum_headers_per_group_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout,\
	"maximum_headers_per_group_input_field_cb(): arg none\n");
	}
}/* end function maximum_headers_per_group_input_field_cb */


void connect_to_server_timeout_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout,\
	"connect_to_server_timeout_input_filed_cb(): arg none\n");
	}
}/* end function connect_to_server_timeout_input_field_cb */


void tab_size_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "tab_size_input_field_cb(): arg none\n");
	}
}/* end function tab_size_input_field_cb */


void helpers_editor_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "helpers_editor_cb(): arg none\n");
	}
/*setup_modified_flag = 1;*/
}/* end function helpers_editor_cb */


void setup_accept_button_cb(FL_OBJECT *ob, long data)
{
char *ptr;
FILE *autoconnect_filefd;
FILE *autodisconnect_filefd;
FILE *autoexecute_filefd;

/* test if auto connect file exists */
if( fl_get_button(fdui -> auto_connect_to_net_button) )
	{
	ptr = (char *) fl_get_input(fdui -> auto_connect_to_net_input_field);
	autoconnect_filefd = fopen(ptr, "r");
	if(! autoconnect_filefd)
		{
		fl_show_alert(\
		"Cannot open connect to net file", ptr, "file not found", 0); 
		return;/* abort */
		}
	else fclose(autoconnect_filefd);
	}

/* test if auto disconnect file exists */
if(fl_get_button(fdui -> auto_disconnect_from_net_button) )
	{
	ptr =\
	(char *) fl_get_input(fdui -> auto_disconnect_from_net_input_field);
	autodisconnect_filefd = fopen(ptr, "r");
	if(! autodisconnect_filefd)
		{
		fl_show_alert("Cannot open disconnect from net file", ptr,\
		"file not found", 0); 
		return;/* abort */
		}
	else fclose(autodisconnect_filefd);
	}

/* test if auto execute file exists */
if(fl_get_button(fdui -> auto_execute_application_button) )
	{
	ptr =\
	(char *) fl_get_input(fdui -> auto_execute_application_input_field);
	autoexecute_filefd = fopen(ptr, "r");
	if(! autoexecute_filefd)
		{
		fl_show_alert("Cannot find application", ptr,\
		"file not found", 0); 
		return;/* abort */
		}
	else fclose(autoexecute_filefd);
	}

fl_hide_form(fd_xagent -> setup);
/* save new one to disk */
if(! save_helpers() )
	{
	fl_show_alert("Could not save helpers file", "helpers file not modified",\
	"", 0);
	return;/* abort */
	}

/* read back from disk into structure */	
if(! load_helpers() )
	{
	fl_show_alert("helpers file was modified but:", "could not load it",\
	"please check for syntax errors", 0);
	return;/* abort */
	}

save_preferences();/* this will write the text fields to disk */
load_preferences();/* this will set the variables from disk */

/* for tabs */
refresh_screen(selected_group);

if(debug_flag)
	{
	fprintf(stdout, "news_server_name=%s\n", news_server_name);
	fprintf(stdout, "mail_server_name=%s\n", mail_server_name);
	fprintf(stdout, "user_email_address=%s\n", user_email_address);
	fprintf(stdout, "user_name=%s\n", user_name);	
	}
}/* end function setup_accept_button_cb */


void setup_cancel_button_cb(FL_OBJECT *ob, long data)
{
/* restore from disc */
load_preferences();
load_helpers();
fl_hide_form(fd_xagent -> setup);
}/* end function setup_cancel_button_cb */


